VariableLangevinIntegrator Class Reference

This is an error contolled, variable time step Integrator that simulates a System using Langevin dynamics. More...

`#include <VariableLangevinIntegrator.h>`

Inheritance diagram for VariableLangevinIntegrator:

## Public Member Functions

| VariableLangevinIntegrator (double temperature, double frictionCoeff, double errorTol)
| Create a VariableLangevinIntegrator. More...
double | getTemperature () const
| Get the temperature of the heat bath (in Kelvin). More...
void | setTemperature (double temp)
| Set the temperature of the heat bath (in Kelvin). More...
double | getFriction () const
| Get the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps). More...
void | setFriction (double coeff)
| Set the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps). More...
double | getErrorTolerance () const
| Get the error tolerance. More...
void | setErrorTolerance (double tol)
| Set the error tolerance. More...
int | getRandomNumberSeed () const
| Get the random number seed. More...
void | setRandomNumberSeed (int seed)
| Set the random number seed. More...
void | step (int steps)
| Advance a simulation through time by taking a series of time steps. More...
void | stepTo (double time)
| Advance a simulation through time by taking a series of steps until a specified time is reached. More...
Public Member Functions inherited from Integrator
| Integrator ()
virtual | ~Integrator ()
double | getStepSize () const
| Get the size of each time step, in picoseconds. More...
void | setStepSize (double size)
| Set the size of each time step, in picoseconds. More...
double | getConstraintTolerance () const
| Get the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...
void | setConstraintTolerance (double tol)
| Set the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...

## Protected Member Functions

void | initialize (ContextImpl &context)
| This will be called by the Context when it is created. More...
void | cleanup ()
| This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup. More...
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Integrator. More...
double | computeKineticEnergy ()
| Compute the kinetic energy of the system at the current time. More...
Protected Member Functions inherited from Integrator
virtual void | stateChanged (State::DataType changed)
| This will be called by the Context when the user modifies aspects of the context state, such as positions, velocities, or parameters. More...

## Additional Inherited Members

Protected Attributes inherited from Integrator
ContextImpl * | context
Context * | owner

## Detailed Description

This is an error contolled, variable time step Integrator that simulates a System using Langevin dynamics.

It compares the result of the Langevin integrator to that of an explicit Euler integrator, takes the difference between the two as a measure of the integration error in each time step, and continuously adjusts the step size to keep the error below a specified tolerance. This both improves the stability of the integrator and allows it to take larger steps on average, while still maintaining comparable accuracy to a fixed step size integrator.

It is best not to think of the error tolerance as having any absolute meaning. It is just an adjustable parameter that affects the step size and integration accuracy. You should try different values to find the largest one that produces a trajectory sufficiently accurate for your purposes. 0.001 is often a good starting point.

## Constructor & Destructor Documentation

VariableLangevinIntegrator | ( | double | temperature,
|  | double | frictionCoeff,
|  | double | errorTol
| ) |  |

Create a VariableLangevinIntegrator.

Parameters

  temperature | the temperature of the heat bath (in Kelvin)
  frictionCoeff | the friction coefficient which couples the system to the heat bath (in inverse picoseconds)
  errorTol | the error tolerance

## Member Function Documentation

void cleanup | ( |  | ) |

protectedvirtual

This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup.

It will also get called again if the application calls reinitialize() on the Context.

Reimplemented from Integrator.

double computeKineticEnergy | ( |  | ) |

protectedvirtual

Compute the kinetic energy of the system at the current time.

Implements Integrator.

double getErrorTolerance | ( |  | ) | const

inline

Get the error tolerance.

double getFriction | ( |  | ) | const

inline

Get the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps).

Returns
  the friction coefficient, measured in 1/ps

std::vector<std::string> getKernelNames | ( |  | ) |

protectedvirtual

Get the names of all Kernels used by this Integrator.

Implements Integrator.

int getRandomNumberSeed | ( |  | ) | const

inline

Get the random number seed.

See setRandomNumberSeed() for details.

double getTemperature | ( |  | ) | const

inline

Get the temperature of the heat bath (in Kelvin).

Returns
  the temperature of the heat bath, measured in Kelvin

void initialize | ( | ContextImpl & | context | ) |

protectedvirtual

This will be called by the Context when it is created.

It informs the Integrator of what context it will be integrating, and gives it a chance to do any necessary initialization. It will also get called again if the application calls reinitialize() on the Context.

Implements Integrator.

void setErrorTolerance | ( | double | tol | ) |

inline

Set the error tolerance.

void setFriction | ( | double | coeff | ) |

inline

Set the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps).

Parameters

  coeff | the friction coefficient, measured in 1/ps

void setRandomNumberSeed | ( | int | seed | ) |

inline

Set the random number seed.

The precise meaning of this parameter is undefined, and is left up to each Platform to interpret in an appropriate way. It is guaranteed that if two simulations are run with different random number seeds, the sequence of random forces will be different. On the other hand, no guarantees are made about the behavior of simulations that use the same seed. In particular, Platforms are permitted to use non-deterministic algorithms which produce different results on successive runs, even if those runs were initialized identically.

If seed is set to 0 (which is the default value assigned), a unique seed is chosen when a Context is created from this Force. This is done to ensure that each Context receives unique random seeds without you needing to set them explicitly.

void setTemperature | ( | double | temp | ) |

inline

Set the temperature of the heat bath (in Kelvin).

Parameters

  temp | the temperature of the heat bath, measured in Kelvin

void step | ( | int | steps | ) |

virtual

Advance a simulation through time by taking a series of time steps.

Parameters

  steps | the number of time steps to take

Implements Integrator.

void stepTo | ( | double | time | ) |

Advance a simulation through time by taking a series of steps until a specified time is reached.

When this method returns, the simulation time will exactly equal the time which was specified. If you call this method and specify a time that is earlier than the current time, it will return without doing anything.

Parameters

  time | the time to which the simulation should be advanced

The documentation for this class was generated from the following file:

- VariableLangevinIntegrator.h